<template lang="pug">
  section
    //- section
      //- div.sub-nav
      //-   b-button(@click="gunTrigger" :class="{active: isActiveGuns}") Oruzje
      //-   b-button(@click="ammoTrigger" :class="{active: isActiveAmmo}") Municija
    section.section.main(v-if="!loading")
      b-collapse.card(:open='showFilters' animation='slide')
        template(#trigger='props')
          .card-header(role='button' :aria-expanded="true")
            p.card-header-title
              | {{$t('filters')}}
            a.card-header-icon
              box-icon(name='down-arrow')
        .card-content
          .filter
            section
              section
              div.filter-search
                b-input(placeholder="Search..." type="search" icon-pack="mdi" icon="search" v-model="search" @input="triggerFilter()")
              div.collapse-display
                span.display-title {{$t('manufacturers')}}
                .checkbox-container.columns
                  b-checkbox.column(v-for="manuf in manufs" :key="manuf.data.id" v-model="manufFilters" :native-value="manuf.data.id" @input="triggerFilter()") {{ manuf.data.attributes.name }}
                div.divider-line
              div.collapse-display
                span.display-title {{$t('caliber')}}
                .checkbox-container.columns
                  b-checkbox.column(v-for="calib in calibs" :key="calib.data.id" v-model="caliberFilters" :native-value="calib.data.id" @input="triggerFilter()") {{ calib.data.attributes.name }}
                div.divider-line
              div.collapse-display
                span.display-title {{$t('type')}}
                .checkbox-container.columns
                  b-checkbox.column(v-for="kind in kinds" :key="kind" v-model="kindFilters" :native-value="kind" @input="triggerFilter()") {{$t(`weaponType${kind.toUpperCase()}`)}}
                div.divider-line
              div.collapse-display
                div.collapse-trigger-title
                  span.display-title {{$t('priceRange')}}
                    div.range-input.checkbox-container
                      div.input-container
                        b-field
                          b-input(class="price-input" v-model="priceMin" placeholder="min" :value='priceMin' @input="triggerFilter()")
                        span.dash -
                        b-field
                          b-input(class="price-input" v-model="priceMax" placeholder="max" :value='priceMax' @input="triggerFilter()")
                      div.range-container
                        b-field
                          b-slider.range-slider(v-model="numbers" :min='sliderMin' :max='sliderMax' :step='100' :ticks="false" @input="triggerSlider()" @change="triggerFilter()")
              div.filter-reset
                b-button(@click="resetFilters()") {{$t('filterReset')}}
      section.section.content
        div.sort
          span.products-number {{$t('totalProducts')}} ({{shown.length}})
          b-dropdown(aria-role="list")
            template(#trigger='{ active }')
              b-button(:label="$t('sort')" type="is-primary")
            b-dropdown-item(aria-role="listitem" :class="sorter === 'def' ? 'active sorter' : ''" @click="sortItems('def')") {{$t('recommended')}}
            b-dropdown-item(aria-role="listitem" :class="sorter === 'nasc' ? 'active sorter' : ''" @click="sortItems('nasc')") {{$t('nameAscending')}}
            b-dropdown-item(aria-role="listitem" :class="sorter === 'ndesc' ? 'active sorter' : ''" @click="sortItems('ndesc')") {{$t('nameDescending')}}
            b-dropdown-item(aria-role="listitem" :class="sorter === 'pasc' ? 'active sorter' : ''" @click="sortItems('pasc')") {{$t('priceAscending')}}
            b-dropdown-item(aria-role="listitem" :class="sorter === 'pdesc' ? 'active sorter' : ''" @click="sortItems('pdesc')") {{$t('priceDescending')}}
        div.card-container(v-if="shown.length !== 0")
          Card(
            v-for="item in shown" :key="item.id"
            :id="item.id"
            :name="item.attributes.name"
            :manuf="item.attributes.manufacturer.data.attributes.name"
            :image="item.attributes.images.data[0].attributes.formats.small.url"
            :price="item.attributes.price"
            :discount="item.attributes.discount_price"
            )
        div.card-container(v-else)
          b-message.ds-message #[i.bx.bx-search-alt] {{$t('noProducts')}}
    section.section.main.spread(v-else)
      b-loading(:is-full-page="true" v-model="loading" :can-cancel="false")
</template>

<script>

function matchSearch(search, item) {
  let ok = false
  const attrs = item.attributes
  const searchables = [
    attrs.name,
    attrs.kind,
    attrs.description,
    attrs.manufacturer.data.attributes.name,
    attrs.caliber.data.attributes.name
  ]
  searchables.forEach((searchable) => {
    if (searchable.toLowerCase().includes(search.toLowerCase())) {
      ok = true
    }
  })
  return ok
}

function deepExists(items, item) {
  const ids = []
  items.forEach((inner) => {
    ids.push(inner.data.id)
  })
  return ids.includes(item.data.id)
}

export default {
  data() {
    let manufs = []
    if (this.$route.query.manufacturer) {
      manufs = [parseInt(this.$route.query.manufacturer)]
    }
    return {
      loading: true,
      showFilters: true,
      sorter: 'def',
      // Filters
      search: '',
      numbers: [0, 0],
      priceMin: null,
      priceMax: null,
      sliderMin: null,
      sliderMax: null,
      itemKind: 'weapons',
      // Checks
      manufFilters: manufs,
      caliberFilters: [],
      kindFilters: [],
      // Raw Data
      manufs: [],
      calibs: [],
      weapons: [],
      kinds: [],
      // Processed
      shown: [],
    }
  },
  async fetch() {
    this.priceMin = null
    this.priceMax = null
    this.weapons = (
      await (
        await fetch(
          `https://tohru.luciascipher.com/api/${this.itemKind}?populate=images,manufacturer,caliber`
        )
      ).json()
    ).data
    this.weapons.forEach((weapon) => {
      // if (Math.floor(Math.random() * 2) === 1) {
      //   weapon.attributes.discount_price = Math.floor(weapon.attributes.price * 0.75)
      // }
      const activePrice = weapon.attributes.discount_price
        ? weapon.attributes.discount_price
        : weapon.attributes.price
      if (this.priceMin === null || this.priceMin > activePrice) {
        this.priceMin = activePrice
      }
      if (this.priceMax === null || this.priceMax < activePrice) {
        this.priceMax = activePrice
      }
      if (!deepExists(this.manufs, weapon.attributes.manufacturer)) {
        this.manufs.push(weapon.attributes.manufacturer)
      }
      if (!deepExists(this.calibs, weapon.attributes.caliber)) {
        this.calibs.push(weapon.attributes.caliber)
      }
      if (!this.kinds.includes(weapon.attributes.kind)) {
        if (weapon.attributes.kind) {
          this.kinds.push(weapon.attributes.kind)
        }
      }
      this.kinds.sort()
    })
    this.manufs.sort((a, b) => {
      const aVar = a.data.attributes.name
      const bVar = b.data.attributes.name
      if (aVar > bVar) {
        return 1
      } else if (bVar > aVar) {
        return -1
      } else {
        return 0
      }
    })
    this.calibs.sort((a, b) => {
      const aVar = a.data.attributes.name
      const bVar = b.data.attributes.name
      if (aVar > bVar) {
        return 1
      } else if (bVar > aVar) {
        return -1
      } else {
        return 0
      }
    })
    this.numbers = [this.priceMin, this.priceMax]
    this.weapons.forEach((weapon) => {
      this.shown.push(weapon)
    })
    this.sliderMin = this.priceMin
    this.sliderMax = this.priceMax
    this.triggerFilter()
    this.loading = false
  },
  head() {
    return {
      title: 'Dragon Shooting - Products',
    }
  },
  methods: {
    resetFilters () {
      this.search = ''
      this.manufFilters = []
      this.caliberFilters = []
      this.kindFilters = []
      this.shown = []
      this.numbers = [this.sliderMin, this.sliderMax]
      this.priceMin = this.sliderMin
      this.priceMax = this.sliderMax
      this.triggerFilter()
    },
    triggerFilter () {
      this.shown = []
      this.weapons.forEach((weapon) => {
        const searchOk = this.search ? matchSearch(this.search, weapon) : true
        const manufOk = this.manufFilters.length !== 0 ? this.manufFilters.includes(weapon.attributes.manufacturer.data.id) : true
        const calibOk = this.caliberFilters.length !== 0 ? this.caliberFilters.includes(weapon.attributes.caliber.data.id) : true
        const kindOk = this.kindFilters.length !== 0 ? this.kindFilters.includes(weapon.attributes.kind) : true
        const activePrice = weapon.attributes.discount_price ? weapon.attributes.discount_price : weapon.attributes.price
        const priceOk = activePrice >= this.numbers[0] && activePrice <= this.numbers[1]
        if (searchOk && manufOk && calibOk && kindOk && priceOk) {
          this.shown.push(weapon)
        }
      })
      this.generateFilters()
      this.sortItems()
    },
    triggerSlider () {
      this.priceMin = this.numbers[0]
      this.priceMax = this.numbers[1]
      // this.triggerFilter()
    },
    sortItems (srt = null) {
      if (srt) {
        this.sorter = srt
      }
      if (this.sorter === 'def') {
        this.shown.sort((a, b) => {
          if (a.attributes.promoted && !b.attributes.promoted) {
            return -1
          } else if (!a.attributes.promoted && b.attributes.promoted) {
            return 1
          } else {
            return 0
          }
        })
      }
      if (this.sorter === 'nasc') {
        this.shown.sort((a, b) => {
          const aVar = `${a.attributes.manufacturer.data.attributes.name}:${a.attributes.name}`
          const bVar = `${b.attributes.manufacturer.data.attributes.name}:${b.attributes.name}`
          if (aVar > bVar) {
            return 1
          } else if (bVar > aVar) {
            return -1
          } else {
            return 0
          }
        })
      }
      if (this.sorter === 'ndesc') {
        this.shown.sort((a, b) => {
          const aVar = `${a.attributes.manufacturer.data.attributes.name}:${a.attributes.name}`
          const bVar = `${b.attributes.manufacturer.data.attributes.name}:${b.attributes.name}`
          if (aVar > bVar) {
            return -1
          } else if (bVar > aVar) {
            return 1
          } else {
            return 0
          }
        })
      }
      if (this.sorter === 'pasc') {
        this.shown.sort((a, b) => {
          const aPrice = a.attributes.discount_price ? a.attributes.discount_price : a.attributes.price
          const bPrice = b.attributes.discount_price ? b.attributes.discount_price : b.attributes.price
          return aPrice - bPrice
        })
      }
      if (this.sorter === 'pdesc') {
        this.shown.sort((a, b) => {
          const aPrice = a.attributes.discount_price ? a.attributes.discount_price : a.attributes.price
          const bPrice = b.attributes.discount_price ? b.attributes.discount_price : b.attributes.price
          return bPrice - aPrice
        })
      }
    },
    generateFilters () {
      this.manufs = []
      this.calibs = []
      this.kinds = []
      this.shown.forEach((weapon) => {
        const activePrice = weapon.attributes.discount_price
          ? weapon.attributes.discount_price
          : weapon.attributes.price
        if (this.sliderMin === null || this.sliderMin > activePrice) {
          this.sliderMin = activePrice
        }
        if (this.sliderMax === null || this.sliderMax < activePrice) {
          this.sliderMax = activePrice
        }
        if (!deepExists(this.manufs, weapon.attributes.manufacturer)) {
          this.manufs.push(weapon.attributes.manufacturer)
        }
        if (!deepExists(this.calibs, weapon.attributes.caliber)) {
          this.calibs.push(weapon.attributes.caliber)
        }
        if (!this.kinds.includes(weapon.attributes.kind)) {
          if (weapon.attributes.kind) {
            this.kinds.push(weapon.attributes.kind)
          }
        }
      })
    }
  },
}
</script>
<style lang="scss" scoped>
.spread {
  min-height: 25rem;
}
.price-input input {
  max-width: none !important;
}
.sub-nav {
  top: 7rem;
  position: fixed;
  background-color: #2c3035;
  z-index: 10;
  width: 100%;
  button {
    background-color: transparent;
    color: #fff;
    border: none;
    &.active {
      background-color: #fff;
      color: #2c3035;
    }
  }
}
.active.sorter {
  border-bottom: 1px solid #006d77;
  color: #006d77;
  font-weight: 700;
}
section.main {
  .button {
    border-radius: 0;
  }
  .collapse.card {
    margin-top: 3em;
    width: 20em;
    height: 100%;
  }
  .filter {
    width: 17em;
    height: 50%;
    min-width: 17em;
    .filter-search {
      display: flex;
      padding-top: 1em;
      flex-direction: row;
      justify-content: space-around;
      align-content: center;
      align-items: center;
    }
    .collapse-display {
      display: flex;
      flex-direction: column;
      align-items: center;
      flex-wrap: nowrap;
      .collapse {
        width: 75%;
      }
      .divider-line {
        border-bottom: 1px solid #c9c9c9;
        height: 1px;
        width: 75%;
      }
      span.display-title {
        min-width: 12.6em;
        max-width: 12.6em;
        padding-left: 0.5em;
        display: flex;
        flex-direction: column;
        justify-content: center;
        align-items: flex-start;
        flex-wrap: wrap;
        padding-bottom: 6px;
        font-size: 20px;
        font-weight: bold;
        * {
          padding-bottom: 0.1em;
          font-size: 15px;
          text-transform: capitalize;
        }
      }
    }
    .filter-reset {
      padding-top: 1em;
      display: flex;
      flex-direction: row;
      justify-content: center;
      padding-bottom: 2em;
    }

    #tip {
      display: flex;
      align-items: center;
      flex-direction: column;
    }
    .collapse-content {
      display: flex;
      flex-direction: column;
      align-items: center;
      .column {
        padding-bottom: 6px;
        padding-top: 6px;
      }
    }
    .checkbox-container {
      display: block;
      flex-direction: row;
      flex-wrap: wrap;
      justify-content: center;
      align-items: center;
      max-width: 225px;
      margin-bottom: 0;
      .b-checkbox.checkbox:not(.button) {
        width: 14em;
        & + .checkbox:last-child {
          margin-right: 0.5em;
        }
      }
    }
    .range-title {
      padding-top: 0.7em;
      font-size: 20px;
      font-weight: bold;
      text-transform: capitalize;
    }
    .range-input {
      display: flex;
      flex-direction: column;
      justify-content: space-around;
      flex-wrap: nowrap;
      padding-top: 0;
      .field {
        width: 25%;
        &:not(:last-child) {
          padding-bottom: 0;
        }
      }
      .input-container {
        display: flex;
        flex-direction: row;
        justify-content: space-evenly;
        align-items: flex-start;
        padding-top: 0;
        width: 13.5em;
        .field {
          width: 5.5em;
        }
        .dash {
          margin-left: 0.5em;
          margin-right: 0.5em;
          font-size: 25px;
        }
      }
      .range-container {
        display: flex;
        width: 50em;
        flex-direction: row;
        justify-content: space-around;
        align-items: center;
        padding-top: 0;
        height: 2em;
        .range-slider {
          width: 97%;
        }
      }
    }
  }
  .content {
    .sort {
      display: flex;
      flex-direction: row;
      justify-content: space-between;
      align-items: center;
      align-content: center;
      flex-wrap: nowrap;
      max-width: 86.5em;
      padding-bottom: 5em;
      .products-number {
        padding-left: 1.6em;
      }
    }
    .card-container {
      display: flex;
      flex-direction: row;
      flex-wrap: wrap;
      max-width: 88em;
      justify-content: flex-start;
    }
  }
}
@media only screen and (min-width: 1024px) {
  .section.main {
    margin-top: 3em;
    display: inline-flex;
    flex-direction: row;
    flex-wrap: nowrap;
    justify-content: space-around;
  }
}
@media only screen and (max-width: 1024px) {
  .section.main {
    display: grid;
    align-content: center;
    justify-content: space-evenly;
    align-items: start;
    justify-items: center;
    padding-top: 0em;
    margin-top: 2em;
    .collapse.card {
      margin-top: 0;
    }
    .filter {
      height: 95%;
      .range-input.checkbox-container {
        .range-container {
          width: 20rem;
          .field {
            width: 14rem;
          }
        }
      }
    }
    .section.content {
      padding-top: 3rem;
    }
  }
}
</style>
